\name{adequatebootstrap}
\alias{adequatebootstrap}
\alias{adequatebootstrap_discriminant}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Computes an adequate bootstrap interval for the parameter of a
  model distribution.
%%  ~~function to do ... ~~
}
\description{
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
}
\usage{
adequatebootstrap(X,distribution,test)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{X}{Data}
  \item{distribution}{The hypothesised distribution. This should be a
    list, with first element the distribution name, and other elements
    with name the name of the parameter and value the initial value of
    that parameter. Available distributions are: "normal", with possible
    parameters "mu", "sigma" and "VaR" (value at risk);
    "log_normal_Poisson" with parameters "mu" and "sigma";
    "pareto", with parameters "alpha" and "min"; "t" with parameters
    "mu", "sigma" and "degrees_of_freedom"; and "Poisson" with parameter "lambda"}
  \item{test}{The model adequacy test to be used. This should be a
    string giving the name of the test. Currently supported options are:
    "AD" for Anderson-Darling; "KS" for Kolmogorov-Smirnov; and
    "ChiSquare" for Pearson Chi-squared. The test name can be followed
    with a level specification using the "@" character. For example
    "AD@0.01" specifies to use the Anderson-Darling test at the 1\% significance level. }
}
\details{
  The Adequate Bootstrap first calculates the sample size at which a
  non-parametric bootstrap has a 50\% probability of rejecting the model
  adequacy test. It then performs a bootstrap at this sample size, and
  takes the appropriate quantiles of the sampling distribution of
  parameter estimates on this bootstrap
}


\value{
  \item{size}{The sample size for the bootstraps. The function censors
  this value from below at 20. That is, it will not generate bootstraps
  of size less than 20. Thus a value of 20 can indicate that the model
  fit is even worse than suggested. Usually a value of 20 here indicates
  that the model should not be used.} 
\item{interval}{The corresponding adequate bootstrap interval.}
%\item{CV}{estimate of mean squared error using
%  leave-one-out cross-validation (not returned by
%  \code{totalcovariancediagonal}} 
}
%\references{}
\author{Toby Kenney \email{tkenney@mathstat.dal.ca}}
%\note{}

%% ~Make other sections like Warning with \section{Warning }{....} ~

%\seealso{}
\examples{
library(AdequateBootstrap)
X<-c(rnorm(990),rnorm(10)*5)
#standard normal with 1\% contamination from a normal with standard
#deviation 5.
ab<-adequatebootstrap(X,"normal","KS@0.1")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{models}
\keyword{regression}% __ONLY ONE__ keyword per line
