#include "data.h"
#include "distributions.h"
#include <cstring>
#include <iostream>
#include <boost/math/distributions/normal.hpp>


using namespace std;



Distribution* get_distribution(const char *const name);

Distribution* read_distribution(int argc,const char *const argv[],unsigned int &start){
  Distribution* orig=get_distribution(argv[start]);
  if(orig==NULL){
    //could not find matching distibution
    throw (char)0;//try discrete distribution
    cout<<"Distribution \""<<argv[start]<<"\" not currently supported.\n";
    exit(0);
  };
  Distribution *ans=orig->copy();//Not freed at exit
  for(start++;start<(unsigned)argc;start++){
    char *at=NULL;
    char *eq=NULL;
    unsigned int percent=0;
    char* name=new char[strlen(argv[start])+1];
    strcpy(name,argv[start]);
    unsigned int len=strlen(name);
    for(unsigned int i=0;i<len;i++){
      if(*(name+i)=='@'){
	*(name+i)='\0';
	at=(name+i+1);
      }else if(*(name+i)=='%'){
	*(name+i)='\0';
	percent=1;
      }else if(*(name+i)=='='){
	*(name+i)='\0';
	eq=(name+i+1);	
      };
    };
    long double val=0;
    if(eq!=NULL){
      val=atof(eq);
    };
    long double atval=0;
    if(at!=NULL){
      atval=atof(at);
      if(eq!=NULL&&eq<at){
	*eq='\0';
	*(eq-1)='@';
      }else{
	*at='\0';
	*(at-1)='@';
      };
    };
    unsigned int i=0;
    for(;i<ans->numvalidpars&&strcmp(name,*(ans->validparnames()+i));i++);
    if(i==ans->numvalidpars){
      delete[] name;
      return ans;
    };
    if(eq!=NULL){
      ans->setfixed(i,val);
      //      cout<<"set parameter "<<i<<" to value "<<val<<".\n";
      //      ans->print();
      if(percent){
	ans->unfix(i);
      };
    }else{
      ans->setmain(i,atval);
    };   
    delete[] name;
  };
  return ans;
};

