#include "Options.h"
#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cstring>
#include <exception>
using namespace std;

class file_error: public exception{
  static const char*const header;
  char *message;
  char *filename;
public:
  file_error(const char *const mess,const char *file);
  virtual const char* what() const throw();   
};


file_error::file_error(const char *const mess,const char *file){
  message=new char[strlen(mess)+1];
  strcpy(message,mess);
  filename=new char[strlen(file)+1];
  strcpy(filename,file);
};

const char* file_error::what() const throw() {
  char *full_message=new char[strlen(header)+strlen(message)+strlen(filename)+12];
  strcpy(full_message,header);
  strcat(full_message,message);
  strcat(full_message," file: \"");
  strcat(full_message,filename);
  strcat(full_message,"\"");
  return full_message;
};   



const char*const file_error::header="File Error: ";


option_formatting_error::option_formatting_error(const char *const mess){
  message=new char[strlen(mess)+1];
  strcpy(message,mess);
};

option_formatting_error::option_formatting_error(const char *const mess,const char*values,const char *end){
  message=new char[strlen(mess)+strlen(values)+strlen(end)+1];
  strcpy(message,mess);
  strcat(message,values);
  strcat(message,end);
};


const char* option_formatting_error::what() const throw(){
  char *full_message=new char[strlen(header)+strlen(message)+1];
  strcpy(full_message,header);
  strcat(full_message,message);
  return full_message;
}; 

const char*const option_formatting_error::header="Formatting error: ";






int Option::checkname(const char* nm) const{
  return strcmp(name,nm);
};


void TrueFalseOption::setoption(const char *val,const char *at,const char *at2){
  if(val){
    value=atol(val);
    this->apply();
  }else{
    char *message=new char[strlen(name)+35];
    sprintf(message,"Value needed for option \"%s\".\n",name);
    throw new option_formatting_error(message);
  };
};



void IntOption::setoption(const char *val,const char *at,const char *at2){
  if(val){
    value=atol(val);
    this->apply();
  }else{
    char *message=new char[strlen(name)+35];
    sprintf(message,"Value needed for option \"%s\".\n",name);
    throw new option_formatting_error(message);
  };
};



void SetSeedOption::apply(){
  srand(value);
};


void PointerOption::setoption(const char *val,const char *at,const char *at2){
  value=val;
  atval=at;
  atval2=at2;
  this->apply();
};



void OutputFileStreamOption::apply(){
  if(value==NULL){
    data=&cout;
  }else{
    ofstream *stream=new ofstream(value);
    if(stream->is_open()){
      data=(ostream*)stream;
    }else{
      throw new file_error("Could not open ",value);
    };
  };
};



void NPestimatorOption::apply(){
  if(value==NULL){
    data=&cout;
  }else{
    ofstream *stream=new ofstream(value);
    if(stream){
      data=(ostream*)stream;
    }else{
      throw new file_error("Could not open ",value);
    };
  };
};


void PairNPestimatorOption::apply(){
  if(value==NULL){
    data=&cout;
  }else{
    ofstream *stream=new ofstream(value);
    if(stream){
      data=(ostream*)stream;
    }else{
      throw new file_error("Could not open ",value);
    };
  };
};

