//#include "general.h"
//#include "distributions.h"

#include <boost/math/distributions/normal.hpp>
extern boost::math::normal stdnorm;


extern long double chisqcval;


class AdequacyTest;
class Data;
class Distribution;
class NPestimator;


void analyse_data(Distribution &truedist,AdequacyTest& adequacy_test,const Data &A);


#define NUMBOOTSTRAP 10000

const long double qchisq95[]={3.841459,  5.991465,  7.814728,  9.487729, 11.070498, 12.591587, 14.067140,  15.507313, 16.918978, 18.307038, 19.675138, 21.026070, 22.362032, 23.684791, 24.995790, 26.296228, 27.587112, 28.869299, 30.143527, 31.410433};


void getpos(unsigned int n,const long double *list,unsigned int numps,const unsigned int *pos,long double *to);

class AdequateBootstrapIntervals{
public:
  unsigned int absz;
  long double abl;
  long double abu;
  long double sbl;
  long double sbu;
  long double nbl;
  long double nbu;
  long double nl;
  long double nu;
};





extern std::ofstream savedata;

extern unsigned int jackknife;

extern unsigned int frequency_table;

extern unsigned int grouped_data;

extern unsigned int ngroup;

extern unsigned int maxbssize;



unsigned int solveprobfast(unsigned int n,unsigned int *xvals,AdequacyTest &Ad,Distribution &dist,long double prob,Data &dat);


void read_option(const char* const optname);

Distribution *read_distribution(int argc,const char* const argv[],unsigned int &start);

//#include "regression.cpp"  //Later, will correct this to regression.h

//For regression contexts, we need to do things a little differently.


inline long double rnorm(){
  return quantile(stdnorm,((long double)rand())/RAND_MAX);
};

long double chisqlookup(unsigned int n,long double atval);

extern long double testatval;

void cleanup();
